import { declare, Record } from "./fable-library.2.4.11/Types";
import { unit, option, record, obj, string } from "./fable-library.2.4.11/Reflection";
import { uncurry, equals, createAtom } from "./fable-library.2.4.11/Util";
import { Auto$$$toString$$5A41365E as Auto$0024$0024$0024toString$0024$00245A41365E } from "./Thoth.Json.4.1.0/Encode";
import { Fetch$$$post$$5760677E as Fetch$0024$0024$0024post$0024$00245760677E } from "./Thoth.Fetch.2.0.0/Fetch";
import { promise } from "./Fable.Promise.2.0.0/PromiseImpl";
import { PromiseBuilder$$Run$$212F1D4B as PromiseBuilder$0024$0024Run$0024$0024212F1D4B, PromiseBuilder$$Delay$$62FBFDE1 as PromiseBuilder$0024$0024Delay$0024$002462FBFDE1 } from "./Fable.Promise.2.0.0/Promise";
export const BlocklyLogEntry082720 = declare(function Logging_BlocklyLogEntry082720(arg1, arg2, arg3) {
  this.schema = arg1;
  this.name = arg2;
  this.object = arg3;
}, Record);
export function BlocklyLogEntry082720$reflection() {
  return record("Logging.BlocklyLogEntry082720", [], BlocklyLogEntry082720, () => [["schema", string], ["name", string], ["object", obj]]);
}
export function BlocklyLogEntry082720$$$Create(name, object) {
  return new BlocklyLogEntry082720("ble082720", name, object);
}
export const JupyterLogEntry082720 = declare(function Logging_JupyterLogEntry082720(arg1, arg2, arg3) {
  this.schema = arg1;
  this.name = arg2;
  this.payload = arg3;
}, Record);
export function JupyterLogEntry082720$reflection() {
  return record("Logging.JupyterLogEntry082720", [], JupyterLogEntry082720, () => [["schema", string], ["name", string], ["payload", option(string)]]);
}
export function JupyterLogEntry082720$$$Create(name$$1, payload) {
  return new JupyterLogEntry082720("jle082720", name$$1, payload);
}
export const LogEntry = declare(function Logging_LogEntry(arg1, arg2) {
  this.username = arg1;
  this.json = arg2;
}, Record);
export function LogEntry$reflection() {
  return record("Logging.LogEntry", [], LogEntry, () => [["username", string], ["json", string]]);
}
export const logUrl = createAtom(null);
export const idOption = createAtom(null);
export function filterJson(o) {
  var value, value$$1;

  if (((value = equals(o.object, null), (!value)) ? (value$$1 = equals(o.object.element, null), (!value$$1)) : false) ? String(o.object.element).indexOf("drag") === 0 : false) {
    o.object.newValue = null;
    o.object.oldValue = null;
  }

  return Auto$0024$0024$0024toString$0024$00245A41365E(4, o, null, null, null, {
    ResolveType() {
      return obj;
    }

  });
}
export function LogToServer(logObject) {
  if (logUrl() == null) {} else {
    const url = logUrl();
    let value$$2;
    value$$2 = PromiseBuilder$0024$0024Run$0024$0024212F1D4B(promise, PromiseBuilder$0024$0024Delay$0024$002462FBFDE1(promise, function () {
      let username;

      if (idOption() == null) {
        username = window.location.href;
      } else {
        const id = idOption();
        username = id;
      }

      return Fetch$0024$0024$0024post$0024$00245760677E(url, new LogEntry(username, filterJson(logObject)), null, null, null, null, uncurry(2, null), {
        ResolveType() {
          return unit;
        }

      }, {
        ResolveType() {
          return LogEntry$reflection();
        }

      }).then(function () {
        return Promise.resolve(null);
      });
    }));
    value$$2, null;
  }
}